import java.util.HashMap;

import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.application.Application;
import javafx.application.Platform;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.ObservableList;
import javafx.event.Event;
import javafx.scene.Group;
import javafx.scene.LightBase;
import javafx.scene.Node;
import javafx.scene.PerspectiveCamera;
import javafx.scene.PointLight;
import javafx.scene.Scene;
import javafx.scene.SubScene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 * AvP[VNX
 */
public class ARApplication extends Application implements ARConstant {

	/** Xe[WNA */
	private final static int			STAGE_CLEAR				= 10000;

	/** tF[Y */
	private		int						phase					= 0;

	/**  */
	private		int						timeCtrl				= 0;
	private		int						time					= 0;

	/** Xe[W */
	private		int						stage					= 0;

	/** XRA */
	private		int						score					= 0;

	/** nCXRA */
	private		int						scoreHigh				= 30000;

	/** [h */
	private		int						mode					= 0;

	/** yC */
	private		StackPane				pane					= null;

	/** V[ */
	private		Scene					scene					= null;

	/** 3DV[ */
	private		SubScene				scene3D					= null;

	/** 2DV[ */
	private		SubScene				scene2D					= null;

	/** J */
	private		PerspectiveCamera		camera					= null;

	/**  */
	private		LightBase				light					= null;

	/** pl3D */
	private		ARPanel3D				panel3D					= null;

	/** pl2D */
	private		Group					panel2D					= null;

	/** eLXg */
	private		Text					textKey					= null;
	private		Text					textControlStick		= null;
	private		Text					textReverse				= null;
	private		Text					textStage				= null;
	private		Text					textScore				= null;
	private		Text					textScoreHigh			= null;
	private		Text					textBy					= null;
	private		Text					textStage2				= null;
	private		Text					textGameOver			= null;

	/** L[ĂԈꗗ */
	private HashMap<KeyCode, String>	mapKeyPress				= null;

	// |[YtO
	private		boolean					flgPause				= false;

	// ^Cg
	private		ARSpriteTitleAsteroider	spriteTitleAsteroider	= null;
	private		ARSpriteTitle3D			spriteTitle3D			= null;

	/** [hZNg */
	private		ARSpriteMode			spriteMode				= null;

	/** @ */
	private		ARSpriteShip			spriteShip				= null;

	/** ~j@ */
	private		ImageView				spriteShipMini			= null;

	/** BGM^ʉ */
	private		ARSoundMP3				mp3Title				= null;
	private		ARSoundMP3				mp3Credit				= null;
	private		ARSoundMP3[]			mp3Spaces				= null;
	private		ARSoundMP3				mp3BGM					= null;
	private		ARSoundMP3				mp3Talk1				= null;
	private		ARSoundMP3				mp3Talk2				= null;
	private		ARSoundMP3				mp3StageClear			= null;
	private		ARSoundMP3				mp3StageEnd				= null;
	private		ARSoundMP3				mp3StageStart			= null;
	private		ARSoundMP3				mp3Clash				= null;
	private		ARSoundMP3				mp3GameOver				= null;

	/** |WViBGMj */
	private		int						posBgm					= 0;

	/** ԁiBGMj */
	private		int						timeBgm					= 0;
	private		int						timeBgmNext				= 0;

	/**
	 * s
	 * <pre>
	 * \bhA͂܂܂B
	 * </pre>
	 * @param args 
	 */
	public static void main(String[] args){

		// AvP[VN܂
		launch(args);

	} // end main

	/**
	 * X^[g
	 * <pre>
	 * s܂B
	 * </pre>
	 */
	@Override
	public void start(Stage primaryStage){

		// ObjReaderɃAvP[Vݒ
		ObjReader.setApplication(this);

		// XvCg
		ARSpriteMode.init();
		ARSpriteShip.init();
		ARSpriteAsteroid.init();
		ARSpriteTitleAsteroider.init();
		ARSpriteTitle3D.init();

		// yC𐶐
		pane = new StackPane();

		// V[𐶐
		// Zobt@LɂiŌ̈Abooleanj
		scene = new Scene(pane, ARConstant.WIDTH, ARConstant.HEIGHT, true);

		// wiɂ
		scene.setFill(Color.BLACK);

		// V[ݒ
		primaryStage.setScene(scene);

		// ^Cgݒ
		primaryStage.setTitle("ASTEROIDER");

		// EBhEۂɈSɏI
		primaryStage.setOnCloseRequest(req -> {
			// JavaFXAvP[VI
			Platform.exit();
			// ɏIĂȂXbhI
			System.exit(0);
		});

		// BGMEʉ𐶐
		mp3Title = new ARSoundMP3(this, "sound/Asteroider.mp3", true);
		mp3Credit = new ARSoundMP3(this, "sound/waveCredit.mp3", false);
		mp3Spaces = new ARSoundMP3[4];
		mp3Spaces[0] = new ARSoundMP3(this, "sound/waveSpace0.mp3", false);
		mp3Spaces[1] = new ARSoundMP3(this, "sound/waveSpace1.mp3", false);
		mp3Spaces[2] = new ARSoundMP3(this, "sound/waveSpace2.mp3", false);
		mp3Spaces[3] = new ARSoundMP3(this, "sound/waveSpace3.mp3", false);
		mp3BGM = new ARSoundMP3(this, "sound/Asteroider2.mp3", true);
		mp3Talk1 = new ARSoundMP3(this, "sound/PasseThroughTheAsteroidBelt.mp3", false);
		mp3Talk2 = new ARSoundMP3(this, "sound/AlsoAsteroidBelt.mp3", false);
		mp3StageClear = new ARSoundMP3(this, "sound/waveStageClear.mp3", false);
		mp3StageEnd = new ARSoundMP3(this, "sound/waveStageEnd.mp3", false);
		mp3StageStart = new ARSoundMP3(this, "sound/waveStageStart.mp3", false);
		mp3Clash = new ARSoundMP3(this, "sound/waveClash.mp3", false);
		mp3GameOver = new ARSoundMP3(this, "sound/waveGameOver.mp3", false);

		// O[v𐶐
		panel3D = new ARPanel3D(this);

		// TuV[𐶐
		scene3D = new SubScene(panel3D, ARConstant.WIDTH, ARConstant.HEIGHT, true, null);

		// yCɒǉ
		pane.getChildren().add(scene3D);

		// Jݒ
		initCamera();

		// ݒ
		initLight();

		// O[v𐶐
		panel2D = new Group();

		// XvCgꗗ𐶐
		scene2D = new SubScene(panel2D, ARConstant.WIDTH, ARConstant.HEIGHT);

		// XvCgwꗗɒǉ
		pane.getChildren().add(scene2D);

		// ~j@𐶐
		spriteShipMini = new ImageView(new Image("2d/ShipMini.png"));

		// ~j@ǉ
		panel2D.getChildren().add(spriteShipMini);

		// eLXg𐶐
		textKey = new Text(300, 500, "PUSH SPACE KEY");
		textControlStick = new Text(320, 550, "CONTROL STICK MODE");
		textReverse = new Text(320, 580, "REVERSE MODE");
		textStage = new Text(100, 20, "STAGE:" + stage);
		textScore = new Text(288, 20, "SCORE:" + score);
		textScoreHigh = new Text(512, 20, "HIGH-SCORE:" + scoreHigh);
		textBy = new Text(220, 720, "PROGRAMED  BY  KIN  /  MUSIC  BY  Aki2");
		textStage2 = new Text(336, 400, "STAGE");
		textGameOver = new Text(320, 400, "GAME OVER");

		// tHgݒ
		textKey.setFont(new Font(32));
		textControlStick.setFont(new Font(20));
		textReverse.setFont(new Font(20));
		textStage.setFont(new Font(null, 20));
		textScore.setFont(new Font(null, 20));
		textScoreHigh.setFont(new Font(20));
		textBy.setFont(new Font(20));
		textStage2.setFont(new Font(32));
		textGameOver.setFont(new Font(32));

		// F̐ݒ
		textKey.setFill(Color.WHITE);
		textControlStick.setFill(Color.YELLOW);
		textReverse.setFill(Color.LIGHTGRAY);
		textStage.setFill(Color.WHITE);
		textScore.setFill(Color.WHITE);
		textScoreHigh.setFill(Color.WHITE);
		textBy.setFill(Color.WHITE);
		textStage2.setFill(Color.WHITE);
		textGameOver.setFill(Color.WHITE);

		// eLXgǉ
		panel2D.getChildren().add(textStage);
		panel2D.getChildren().add(textScore);
		panel2D.getChildren().add(textScoreHigh);

		// A[v
		for(int i = 0; i < 300; i++){

			// 𐶐
			ARSpriteStardust spriteStardust = new ARSpriteStardust();

			// m[hǉ
			this.addNode(spriteStardust);

		} // end for

		// ^Cg𐶐
		spriteTitleAsteroider = new ARSpriteTitleAsteroider(this);
		spriteTitle3D = new ARSpriteTitle3D(this);

		// L[󋵈ꗗ𐶐
		mapKeyPress = new HashMap<KeyCode, String>();

		// L[Cxgo^
		scene.addEventHandler(KeyEvent.KEY_PRESSED, event -> sceneKeyPressed(event));

		// L[𗣂Cxgo^
		scene.addEventHandler(KeyEvent.KEY_RELEASED, event -> sceneKeyReleased(event));

		// EChETCYύXXi[ǉ
		pane.widthProperty().addListener((observable, oldValue, newValue) -> windowResized());
		pane.heightProperty().addListener((observable, oldValue, newValue) -> windowResized());

		// EBhE\
		primaryStage.show();

		// ԏ
		timeCtrl = 0;
		time = 0;

		// ^C}[X^[g
		Timeline timer = new Timeline(new KeyFrame(Duration.millis(4), event -> runCtrl()));
		timer.setCycleCount(Timeline.INDEFINITE);
		timer.play();

	} // end start

	/**
	 * ^C}[s
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void runCtrl() {

		// ԁ{P
		timeCtrl++;

		// AvP[V|̎
		if(timeCtrl % 4 == 0){

			// AvP[V|s\bhĂяo
			run();

		// em[h̐̎
		}else if(timeCtrl % 4 == 1){

			// 3Dpls
			panel3D.run();

		// |̎
		}else if(timeCtrl % 4 == 3){

			// 3Dpl̃N[\bhs
			panel3D.clean();

		}

	} // end runCtrl

	/**
	 * s
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void run() {

		// ԁ{P
		time++;

		// tF[Y|̏ꍇA
		if(phase == PHASE_INIT){

			// Xe[W
			stage = 0;

			// XRA
			score = 0;

			// ԏ
			time = 0;

			// ^Cg
			spriteTitleAsteroider.initPosition();
			spriteTitle3D.initPosition();

			// tF[Y|^CgP
			phase = PHASE_TITLE_1;

		// tF[Y|^CgP̏ꍇA
		}else if(phase == PHASE_TITLE_1){

			// Rb
			if(time == 180){

				// ^Cgǉ
				this.addNode(spriteTitleAsteroider);
				this.addNode(spriteTitle3D);

			}

			// Xy[XꂽꍇA
			if(this.isKeyPressed(KeyCode.SPACE)){

				// Rb̏ꍇA
				if(time < 180){

					// ^Cgǉ
					this.addNode(spriteTitleAsteroider);
					this.addNode(spriteTitle3D);

				}

				// ^CgXLbv
				spriteTitleAsteroider.skipTitle();
				spriteTitle3D.skipTitle();

				// tF[Y|^CgQ
				phase = PHASE_TITLE_2;

			}

		// tF[Y|^CgQ̏ꍇA
		}else if(phase == PHASE_TITLE_2){

			// ^Cg҂

		// tF[Y|^CgȐꍇA
		}else if(phase == PHASE_TITLE_3){

			// ԂA
			if(time == 1){

				// eLXgǉ
				panel2D.getChildren().add(textKey);
				panel2D.getChildren().add(textControlStick);
				panel2D.getChildren().add(textReverse);
				panel2D.getChildren().add(textBy);

				// [hZNg𐶐
				spriteMode = new ARSpriteMode(this);

				// [hZNgǉ
				this.addNode(spriteMode);

				// BGMX^[g
				mp3Title.start();

			} // end if Ԃ

			// オꂽꍇA
			if(this.isKeyPressed(KeyCode.UP)){

				// [hύX
				mode = 0;

				// [hύX
				spriteMode.setMode(mode);

			// ꂽꍇA
			}else if(this.isKeyPressed(KeyCode.DOWN)){

				// [hύX
				mode = 1;

				// [hύX
				spriteMode.setMode(mode);

			// Xy[XꂽꍇA
			}else if(this.isKeyPressed(KeyCode.SPACE)){

				// ԏ
				time = 0;

				// ^Cg폜
				this.removeNode(spriteTitleAsteroider);
				this.removeNode(spriteTitle3D);

				// eLXg폜
				panel2D.getChildren().remove(textKey);
				panel2D.getChildren().remove(textControlStick);
				panel2D.getChildren().remove(textReverse);
				panel2D.getChildren().remove(textBy);

				// [hZNg폜
				this.removeNode(spriteMode);

				// BGMXgbv
				mp3Title.stop();

				// ʉX^[g
				mp3Credit.start();

				// @𐶐
				spriteShip = new ARSpriteShip(this);

				// [hݒ
				spriteShip.setMode(mode);

				// @ǉ
				this.addNode(spriteShip);

				// tF[Y|Xe[WX^[g
				phase = PHASE_STAGE_START;

			}

		// tF[Y|Xe[WX^[g̏ꍇA
		}else if(phase == PHASE_STAGE_START){

			// ԂA
			if(time == 1){

				// Xe[W{P
				stage++;

				// XRA
				textStage.setText("STAGE:" + stage);

				// eLXg|Xe[WҏW
				textStage2.setText("STAGE " + stage);

				// XRA
				textScore.setText("SCORE:" + score);

				// eLXgǉ
				panel2D.getChildren().add(textStage2);

				// ~j@ړ
				spriteShipMini.setTranslateX((score % STAGE_CLEAR) / (double)STAGE_CLEAR * WIDTH);

				// @X^[g
				spriteShip.start();

			// RbA
			}else if(time == 180){

				// Xe[WQȍ~̏ꍇA
				if(stage >= 2){

					// ʉX^[g
					mp3Talk2.start();

				}

			// SbA
			}else if(time == 240){

				// eLXg폜
				panel2D.getChildren().remove(textStage2);

				// BGMX^[g
				mp3BGM.start();

				// tF[Y|Q[
				phase = PHASE_GAME;

			} // end if Ԃ

		// tF[Y|Q[̏ꍇA
		}else if(phase == PHASE_GAME){

			// XRA{S
			score = score + 4;

			// XRA
			textScore.setText("SCORE:" + score);

			// nCXRAA
			if(score > scoreHigh){

				// nCXRAύX
				scoreHigh = score;

				// nCXRA
				textScoreHigh.setText("HIGH-SCORE:" + scoreHigh);

			}

			// Xe[WNȀꍇA
			if(score % STAGE_CLEAR == 0){

				// ԏ
				time = 0;

				// tF[Y|Xe[WNAP
				phase = PHASE_STAGE_CLEAR_1;

			// Xe[WNAȊȌꍇA
			}else{

				// ~j@ړ
				spriteShipMini.setTranslateX((score % STAGE_CLEAR) / (double)STAGE_CLEAR * WIDTH);

			}

		// tF[Y|Xe[WNAP̏ꍇA
		}else if(phase == PHASE_STAGE_CLEAR_1){

			// 4b
			if(time == 240){

				// ʉX^[g
				mp3Talk1.start();

			// 8b
			}else if(time == 480){

				// BGMXgbv
				mp3BGM.stop();

				// ʉX^[g
				mp3StageClear.start();

			// 10b
			}else if(time == 600){

				// ԏ
				time = 0;

				// ʉX^[g
				mp3StageEnd.start();

				// [v
				spriteShip.warp();

				// [v
				ARSpriteWarp spriteWarp = new ARSpriteWarp(this, spriteShip);

				// AvP[VɃm[hǉ
				this.addNode(spriteWarp);

				// tF[Y|Xe[WNAQ
				phase = PHASE_STAGE_CLEAR_2;

			} // end if 

		// tF[Y|Xe[WNAQ̏ꍇA
		}else if(phase == PHASE_STAGE_CLEAR_2){

			// 6b
			if(time < 360){

				// Ȃ

			// 6b
			}else{

				// ԏ
				time = 0;

				// ʉX^[g
				mp3StageStart.start();

				// tF[Y|Xe[WX^[g
				phase = PHASE_STAGE_START;

			} // end if 

		// tF[Y|NbV̏ꍇA
		}else if(phase == PHASE_CLASH){

			// ԂA
			if(time > 120){

				// ʉX^[g
				mp3GameOver.start();

				// eLXgǉ
				panel2D.getChildren().add(textGameOver);

				// ԏ
				time = 0;

				// tF[Y|Q[I[o[
				phase = PHASE_GAMEOVER;

			}

		// tF[Y|Q[I[o[̏ꍇA
		}else if(phase == PHASE_GAMEOVER){

			// ԂA
			if(time > 300){

				// @폜
				removeNode(spriteShip);

				// ԏ
				time = 0;

				// eLXg폜
				panel2D.getChildren().remove(textGameOver);

				// tF[Y|
				phase = PHASE_INIT;

			}

		} // end if tF[Y

		// tF[Y|Xe[WNAȊȌꍇA
		if(phase != PHASE_STAGE_CLEAR_1 && phase != PHASE_STAGE_CLEAR_2){

			// fѐis
			progress();

		}

		// tF[Y|^Cg^Q[NA^NbV^Q[I[o[ł͂ȂꍇA
		if(phase != PHASE_TITLE_1 && phase != PHASE_TITLE_2 && phase != PHASE_TITLE_3 &&
			phase != PHASE_STAGE_CLEAR_1 && phase != PHASE_STAGE_CLEAR_2 &&
			phase != PHASE_CLASH && phase != PHASE_GAMEOVER){

			// ԁiBGMj{P
			timeBgm++;

			// ʉ}^C~O
			if(timeBgm > timeBgmNext){

				// ʉ
				mp3Spaces[posBgm].init();

				// ʉ}^C~O
				mp3Spaces[posBgm].start();

				// ԁiBGMj
				timeBgm = 0;
				// ̎ԁiBGMj
				timeBgmNext = (int)(Math.random() * 300) + 300;
				// |WViBGMj
				posBgm = (posBgm + 1 + (int)(Math.random() * 3)) % 4;

			} // end if ʉ}^C~O

		} // end if tF[Y|^Cg^Q[NA^NbV^Q[I[o[ł͂Ȃꍇ

	} // end run

	/**
	 * fѐis
	 * <pre>
	 * Xe[WɂAf𐶂ݏo܂B
	 * </pre>
	 */
	private void progress() {

		// x
		int lvl = stage / 3;

		// ^Cg or Xe[WPn̏ꍇA
		if(stage == 0 || stage % 3 == 1){

			// foꍇA
			if(Math.random() < 0.15 + lvl * 0.05){

				// f𐶐
				ARSpriteAsteroid spriteAsteroid = new ARSpriteAsteroid(this, stage);

				// m[hǉ
				this.addNode(spriteAsteroid);

			}

		// Xe[WQn̏ꍇA
		}else if(stage % 3 == 2){

			// foꍇA
			if(Math.random() < 0.40 + lvl * 0.20){

				// f𐶐
				ARSpriteAsteroid spriteAsteroid = new ARSpriteAsteroid(this, stage);

				// m[hǉ
				this.addNode(spriteAsteroid);

			}

		// Xe[WRn̏ꍇA
		}else if(stage % 3 == 0){

			// foꍇA
			if(Math.random() < 0.06 + lvl * 0.03){

				// f𐶐
				ARSpriteAsteroid spriteAsteroid = new ARSpriteAsteroid(this, stage);

				// m[hǉ
				this.addNode(spriteAsteroid);

			}

		} // end if Xe[W

	} // end progress

	/**
	 * tF[Yݒ
	 */
	public void setPhase(int phase){

		// ԏ
		time = 0;

		// tF[YύX
		this.phase = phase;

	} // end setPhase

	/**
	 * |[Y擾
	 * @return boolean true||[Y^false||[Ył͂Ȃ
	 */
	public boolean isPause(){
		return flgPause;
	}

	/**
	 * m[hǉ
	 * <pre>
	 * m[hǉ܂B
	 * </pre>
	 * @param sprite m[h
	 */
	public void addNode(Node node){

		// 3DplNXĂяo
		panel3D.addNode(node);

	}

	/**
	 * m[h폜
	 * <pre>
	 * m[h폜܂B
	 * \bhł́A_~[m[hɒuArun\bh̒ō폜܂B
	 * nullɒułȂ
     *  ListNXremove\bh𑽗p邱ƂŔzRs[𑽗p邱Ƃ邽
	 * idȂ邱Ƃł邾j
	 * </pre>
	 * @param sprite m[h
	 */
	public void removeNode(Node node){

		// 3DplNXĂяo
		panel3D.removeNode(node);

	}

	/**
	 * fBAr[ǉ
	 * @param sprite XvCg
	 */
	public void addMediaView(ARSoundMP3 mp3){

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = pane.getChildren();

		// fBAr[ǉ
		nodeLst.add(mp3);

	} // end addMediaView

	/**
	 * fBAr[폜
	 * <pre>
	 * XvCgwTāAXvCg폜܂B
	 * \bhł́A_~[XvCgɒuArun\bh̒ō폜܂B
	 * nullɒułȂ
     *  ListNXremove\bh𑽗p邱ƂŔzRs[𑽗p邱Ƃ邽
	 * idȂ邱Ƃł邾j
	 * </pre>
	 * @param sprite XvCg
	 */
	public void removeMediaView(ARSoundMP3 mp3){

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = pane.getChildren();

		// CfbNX߂
		int index = nodeLst.indexOf(mp3);

		// CfbNX擾łꍇA
		if(index != -1){

			// 폜
			nodeLst.remove(mp3);

		}

	} // end removeMediaView

	/**
	 * @擾
	 */
	public ARSpriteShip getARSpriteShip(){
		return spriteShip;
	}

	/**
	 * NbV
	 */
	public void clash(){

		// @NbV
		spriteShip.clash();

		// BGMXgbv
		mp3BGM.stop();

		// ʉX^[g
		mp3Clash.start();

		// ԏ
		time = 0;

		// tF[Y|NbV
		phase = PHASE_CLASH;

	} // end clash

	/**
	 * Jݒ
	 */
	private void initCamera(){

		// Jݒ
		camera  = new PerspectiveCamera(true);

		// J̋Ԃݒ
		camera.setFarClip(300);

		// Jݒ
		scene3D.setCamera(camera);

	} // end initCamera

	/**
	 * ݒ
	 */
	private void initLight(){

		// ݒ
		light = new PointLight();

		// ʒu
		light.setTranslateX(0);
		light.setTranslateY(0);
		light.setTranslateZ(0);

		// ݒ
		panel3D.getChildren().add(light);

	} // end initLight

	/**
	 * L[ǂ`FbN
	 * @param code L[R[h
	 * @return boolean trueFĂ ^ falseFĂȂ
	 */
	public boolean isKeyPressed(KeyCode code){

		return mapKeyPress.containsKey(code);

	} // end isKeyPressed

	/**
	 * L[Cxg
	 * <pre>
	 * _LqsāAC^[tF[X쐬ȗĂ܂B
	 * </pre>
	 */
	public void sceneKeyPressed(Event e){

		KeyEvent ke = (KeyEvent)e;
		KeyCode code = ke.getCode();
		mapKeyPress.put(code, "");

	} // end sceneKeyPressed

	/**
	 * L[𗣂Cxg
	 * <pre>
	 * _LqsāAC^[tF[X쐬ȗĂ܂B
	 * </pre>
	 */
	public void sceneKeyReleased(Event e){

		KeyEvent ke = (KeyEvent)e;
		KeyCode code = ke.getCode();
		mapKeyPress.remove(code);

	} // end sceneKeyReleased

	/**
	 * EChETCYύXCxg
	 */
	public void windowResized(){

		// yCiEChEj̃TCY擾
		double widthPane = ARApplication.this.pane.getWidth();
		double heightPane = ARApplication.this.pane.getHeight();

		// 䗦߂
		double ratioWidth = (float)widthPane / ARConstant.WIDTH;
		double ratioHeight = (float)heightPane / ARConstant.HEIGHT;

		// 䗦̏߂
		double ratio = (ratioWidth < ratioHeight)?ratioWidth: ratioHeight;

		// eV[gk
		scene3D.setScaleX(ratio);
		scene3D.setScaleY(ratio);
		scene2D.setScaleX(ratio);
		scene2D.setScaleY(ratio);

		// yC̃V[Ĕzu
		scene3D.setLayoutX((widthPane - ARConstant.WIDTH) / 2);
		scene3D.setLayoutY((heightPane - ARConstant.HEIGHT) / 2);
		scene2D.setLayoutX((widthPane - ARConstant.WIDTH) / 2);
		scene2D.setLayoutY((heightPane - ARConstant.HEIGHT) / 2);

	} // end windowResized

}
