import javafx.scene.input.KeyCode;
import javafx.scene.transform.Rotate;

/**
 * @
 */
public class ARSpriteShip extends ARSprite {

	/** tF[Y|X^[g */
	private final int			PHASE_START		= 0;

	/** tF[Y|Q[ */
	private final int			PHASE_GAME		= 1;

	/** tF[Y|NbV */
	private final int			PHASE_CLASH		= 2;

	/** tF[Y|[v */
	private final int			PHASE_WARP		= 3;

	/** tF[Y */
	private		int				phase			= PHASE_START;

	/**  */
	private		int				time			= 0;

	/** xX */
	private		double			mx				= 0;

	/** xY */
	private		double			my				= 0;

	/** XX */
	private		Rotate			rotateX			= null;
	private		int				angleX			= 0;

	/** XY */
	private		Rotate			rotateY			= null;
	private		int				angleY			= 0;

	/** ړ */
	private		KeyCode			moveUp			= null;

	/** ړ */
	private		KeyCode			moveDown		= null;

	/** G */
	private		boolean			flgMuteki		= false;

	/** NbV */
	private		boolean			flgClash		= false;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(ARSpriteShip.class, "3d/ship.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 */
	public ARSpriteShip(ARApplication applicaton){

		// X[p[NXĂяo
		super(applicaton);

		try{

			// Zݒ
			super.setTranslateZ(10);

			// IuWFNg
			ObjReader.create(this);

			// k
			super.setScaleX(0.1);
			super.setScaleY(0.1);
			super.setScaleZ(0.1);

			// ]
			this.getTransforms().add(new Rotate(180, Rotate.Y_AXIS));

			// Rotate𐶐
			rotateX = new Rotate(angleX, Rotate.Z_AXIS);
			rotateY = new Rotate(angleY, Rotate.X_AXIS);

			// ]pɓo^
			this.getTransforms().add(rotateX);
			this.getTransforms().add(rotateY);

			// G
			flgMuteki = true;

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end ARSpriteShip

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// tF[Y|X^[g
		if(phase == PHASE_START){

			// W
			double l = 0;

			// vX}CiXvZ
			int a = (this.getLayoutX() > 0)?-1: 1;

			// Qb
			if(time < 120){

				// W
				l = 0.8;

			// Sb
			}else if(time < 240){

				// WvZ
				l = 0.8 - (time - 120) / 120.0 * 0.8;

			// Sb
			}else{

				// W
				l = 0;

				// Ԃ
				time = 0;

				// tF[Y|Q[
				phase = PHASE_GAME;

			}

			// WvZ
			double x = l * Math.cos(time * 0.6) * a;
			double y = l * Math.sin(time * 0.6) * a;
			double z = 10.0 - l * 8.0;

			// @̏ꏊݒ
			this.setTranslateX(x);
			this.setTranslateY(y);
			this.setTranslateZ(z);

		// tF[Y|Q[
		}else if(phase == PHASE_GAME){

			// W擾
			double x = this.getTranslateX();
			double y = this.getTranslateY();

			// ړ̏ꍇA
			if(application.isKeyPressed(moveUp)){

				// xvZ
				my = my + ((my > -0.08)?-0.002: 0);

				// XvZ
				angleY--;

			} // end if ړ̏ꍇ

			// ړ̏ꍇA
			if(application.isKeyPressed(moveDown)){

				// xvZ
				my = my + ((my < 0.08)?0.002: 0);

				// XvZ
				angleY++;

			} // end if ړ̏ꍇ

			// ꂽꍇA
			if(application.isKeyPressed(KeyCode.LEFT)){

				// xvZ
				mx = mx + ((mx > -0.08)?-0.002: 0);

				// XvZ
				angleX++;

			} // end if ꂽꍇ

			// EꂽꍇA
			if(application.isKeyPressed(KeyCode.RIGHT)){

				// xvZ
				mx = mx + ((mx < 0.08)?0.002: 0);

				// XvZ
				angleX--;

			} // end if Eꂽꍇ

			// WvZ
			x = x + mx;
			y = y + my;

			// ̈ȌꍇA
			if(y < -2.0){

				// ߂
				y = -2.0;
				my = 0.0;
				angleY = 0;

			}

			// ̈ȌꍇA
			if(y > 2.0){

				// ߂
				y = 2.0;
				my = 0.0;
				angleY = 0;

			}

			// ̈ȌꍇA
			if(x < -2.0){

				// ߂
				x = -2.0;
				mx = 0.0;
				angleX = 0;

			}

			// ̈ȌꍇA
			if(x > 2.0){

				// ߂
				x = 2.0;
				mx = 0.0;
				angleX = 0;

			}

			// Wݒ
			this.setTranslateX(x);
			this.setTranslateY(y);

			// pxݒ
			rotateX.setAngle(angleX);
			rotateY.setAngle(angleY);

			// Rb
			if(time < 180){

				// _
				if(time % 25 < 10){
					this.setVisible(false);
				}else{
					this.setVisible(true);

				}

			// Rb
			}else if(time == 180){

				// \
				this.setVisible(true);

				// Gԉ
				flgMuteki = false;

			} // end if

		// tF[Y|NbV
		}else if(phase == PHASE_CLASH){

			// ȂɂȂ

		// tF[Y|[v
		}else if(phase == PHASE_WARP){

			// PDTb
			if(time < 90){

				// ȂɂȂ

			// RDOb
			}else if(time < 180){

				// ԂvZ
				int time1 = time - 90;

				// ZvZ
				this.setTranslateZ((time1 % 10) * time1 / 30 + 10);

			// RDOb
			}else if(time == 180){

				// ZWU߂
				this.setTranslateZ(10);

			// SDTb
			}else if(time < 270){

				// ZvZ
				this.setTranslateZ(this.getTranslateZ() + 20);

			}

		} // end if tF[Y

	} // end run

	/**
	 * GԎ擾
	 */
	public boolean isMuteki(){
		return flgMuteki;
	}

	/**
	 * NbVԎ擾
	 */
	public boolean isClash(){
		return flgClash;
	}

	/**
	 * NbV
	 */
	public void clash(){

		// NbV
		flgClash = true;

		// 𐶐
		ARSpriteBomb spriteBomb = new ARSpriteBomb(application, this);

		// AvP[Vɔǉ
		application.addNode(spriteBomb);

		// tF[Y|NbV
		phase = PHASE_CLASH;

	} // end clash

	/**
	 * X^[g
	 */
	public void start(){

		// Ԃ
		time = 0;

		// e
		mx = 0;
		my = 0;
		angleY = 0;
		angleX = 0;
		rotateX.setAngle(angleX);
		rotateY.setAngle(angleY);
		flgMuteki = true;

		// tF[Y|X^[g
		phase = PHASE_START;

	} // end start

	/**
	 * [v
	 */
	public void warp(){

		// Ԃ
		time = 0;

		// tF[Y|[v
		phase = PHASE_WARP;

	} // end warp

	/**
	 * [hݒ
	 */
	public void setMode(int mode){

		// [hݒ
		if(mode == 0){
			moveUp = KeyCode.DOWN;
			moveDown = KeyCode.UP;
		}else{
			moveUp = KeyCode.UP;
			moveDown = KeyCode.DOWN;
		}

	} // end run

}
